/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.service;

import java.util.Map;

import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort.Direction;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.portofolio.base.BaseServiceImpl;
import com.portofolio.dao.JenisAlamatDao;
import com.portofolio.dto.JenisAlamatDto;
import com.portofolio.entity.JenisAlamat;
import com.portofolio.entity.vo.JenisAlamatId;
import com.portofolio.exception.InfoException;
import com.portofolio.util.CommonUtil;



@Lazy
@Service
public class JenisAlamatService extends BaseServiceImpl {

	@Lazy
	@Autowired
	private JenisAlamatDao jenisalamatDao;

	@Lazy
	@Autowired
	private LoginUserService loginUserService;
	
	@Lazy
	@Autowired
	private LanguageService languageService;

	@Transactional
	public Map<String, Object> save(JenisAlamatDto jenisalamatDto) {
		result.clear();
		JenisAlamatId id = new JenisAlamatId();
		id.setKdJenisAlamat(getIdTerahir(JenisAlamat.class.getSimpleName()));
		id.setKdProfile(getKdProfile());

		JenisAlamat jenisalamat = CommonUtil.findOne(jenisalamatDao, id);
		if (CommonUtil.isNullOrEmpty(jenisalamat)) {
			jenisalamat = new JenisAlamat();
			BeanUtils.copyProperties(jenisalamatDto, jenisalamat);
			jenisalamat.setId(id);
			jenisalamat.setNoRec(generateUuid32());
			jenisalamat.setVersion(1);
			jenisalamat = jenisalamatDao.save(jenisalamat);
			result.put("jenisAlamat", jenisalamat);
			resultCreated();
		} else {
			throw new InfoException(languageService.getTranslateByKey("jenisAlamat.message.dataAlreadyExist"));
		}

		return result;
	}

	@Transactional
	public Map<String, Object> update(JenisAlamatDto jenisalamatDto, Integer kdJenisAlamat, Integer version) {
		result.clear();
		JenisAlamatId id = new JenisAlamatId();
		id.setKdJenisAlamat(kdJenisAlamat);
		id.setKdProfile(getKdProfile());

		JenisAlamat jenisalamat = CommonUtil.findOne(jenisalamatDao, id);
		if (CommonUtil.isNotNullOrEmpty(jenisalamat)) {
			if (version < jenisalamat.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			BeanUtils.copyProperties(jenisalamatDto, jenisalamat);
			jenisalamat.setVersion(version);
			jenisalamat = jenisalamatDao.save(jenisalamat);
			result.put("jenisAlamat", jenisalamat);
			resultUpdated();
		} else {
			resultNotFound();
		}

		return result;
	}

	
	public Map<String, Object> grid(Integer page, Integer limit, String sort, String dir, String namajenisalamat,boolean statusEnabled) {
		result.clear();
		page--;
		PageRequest pageReq = PageRequest.of(page, limit, "desc".equals(sort) ? Direction.DESC : Direction.ASC, dir);
		Page<Map<String, Object>> pageRes;
		if (CommonUtil.isNullOrEmpty(namajenisalamat)) {
			pageRes = jenisalamatDao.findAllList(getKdProfile(), statusEnabled, pageReq);
		} else {
			pageRes = jenisalamatDao.findAllList(getKdProfile(), namajenisalamat, statusEnabled, pageReq);
		}
		result.put("jenisAlamat", pageRes.getContent());
		result.put("totalPages", pageRes.getTotalPages());
		result.put("totalRow", pageRes.getTotalElements());
		resultSuccessful();

		return result;
	}

	
	public Map<String, Object> findByKdJenisAlamat(Integer kdJenisAlamat) {
		result.clear();
		Map<String, Object> jenisalamat = jenisalamatDao.findByKdJenisAlamat(getKdProfile(), kdJenisAlamat,CONSTANT_STATUS_ENABLED_TRUE);
		result.put("jenisAlamat", jenisalamat);
		resultSuccessful();
		return result;
	}

	@Transactional
	public Map<String, Object> deleteByKdJenisAlamat(Integer kdJenisAlamat, Integer version) {

		result.clear();

		JenisAlamatId id = new JenisAlamatId();
		id.setKdJenisAlamat(kdJenisAlamat);
		id.setKdProfile(getKdProfile());

		JenisAlamat jenisalamat = CommonUtil.findOne(jenisalamatDao, id);
		if (CommonUtil.isNotNullOrEmpty(jenisalamat)) {
			if (version < jenisalamat.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			jenisalamat.setVersion(version);
			jenisalamat = jenisalamatDao.save(jenisalamat);
			result.put("jenisAlamat", jenisalamat);
			resultDeleted();
		} else {
			resultNotFound();
		}

		return result;

	}
}
